Index: /NEMO/trunk/src/OCE/IOM/restart.F90
===================================================================
--- /NEMO/trunk/src/OCE/IOM/restart.F90	(revision 10424)
+++ /NEMO/trunk/src/OCE/IOM/restart.F90	(revision 10425)
@@ -28,4 +28,5 @@
    USE iom             ! I/O module
    USE diurnal_bulk
+   USE lib_mpp         ! distribued memory computing library
 
    IMPLICIT NONE
@@ -97,8 +98,5 @@
                WRITE(numout,*)
                IF(.NOT.lwxios) THEN
-                  SELECT CASE ( jprstlib )
-                  CASE DEFAULT         ;   WRITE(numout,*)                            &
-                      '             open ocean restart NetCDF file: ',TRIM(clpath)//TRIM(clname)
-                  END SELECT
+                  WRITE(numout,*) '             open ocean restart NetCDF file: ',TRIM(clpath)//TRIM(clname)
                   IF ( snc4set%luse )      WRITE(numout,*) '             opened for NetCDF4 chunking and compression'
                   IF( kt == nitrst - 1 ) THEN   ;   WRITE(numout,*) '             kt = nitrst - 1 = ', kt
@@ -109,5 +107,5 @@
             !
             IF(.NOT.lwxios) THEN
-               CALL iom_open( TRIM(clpath)//TRIM(clname), numrow, ldwrt = .TRUE., kiolib = jprstlib )
+               CALL iom_open( TRIM(clpath)//TRIM(clname), numrow, ldwrt = .TRUE. )
             ELSE
 #if defined key_iomput
@@ -137,5 +135,5 @@
       !!                   ***  ROUTINE rstwrite  ***
       !!                     
-      !! ** Purpose :   Write restart fields in the format corresponding to jprstlib
+      !! ** Purpose :   Write restart fields in NetCDF format
       !!
       !! ** Method  :   Write in numrow when kt == nitrst in NetCDF
@@ -146,4 +144,5 @@
                      IF(lwxios) CALL iom_swap(      cwxios_context          )
                      CALL iom_rstput( kt, nitrst, numrow, 'rdt'    , rdt       , ldxios = lwxios)   ! dynamics time step
+                     CALL iom_delay_rst( 'WRITE', 'OCE', numrow )   ! save only ocean delayed global communication variables
 
       IF ( .NOT. ln_diurnal_only ) THEN
@@ -197,10 +196,9 @@
       !!                   ***  ROUTINE rst_read_open  ***
       !! 
-      !! ** Purpose :   Open read files for restart (format fixed by jprstlib )
+      !! ** Purpose :   Open read files for NetCDF restart
       !! 
       !! ** Method  :   Use a non-zero, positive value of numror to assess whether or not
       !!                the file has already been opened
       !!----------------------------------------------------------------------
-      INTEGER        ::   jlibalt = jprstlib
       LOGICAL        ::   llok
       CHARACTER(lc)  ::   clpath   ! full path to ocean output restart file
@@ -210,7 +208,5 @@
          IF(lwp) THEN                                             ! Contol prints
             WRITE(numout,*)
-            SELECT CASE ( jprstlib )
-            CASE ( jpnf90    )   ;   WRITE(numout,*) 'rst_read : read oce NetCDF restart file'
-            END SELECT
+            WRITE(numout,*) 'rst_read : read oce NetCDF restart file'
             IF ( snc4set%luse )      WRITE(numout,*) 'rst_read : configured with NetCDF4 support'
             WRITE(numout,*) '~~~~~~~~'
@@ -219,5 +215,5 @@
          clpath = TRIM(cn_ocerst_indir)
          IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath) // '/'
-         CALL iom_open( TRIM(clpath)//cn_ocerst_in, numror, kiolib = jlibalt )
+         CALL iom_open( TRIM(clpath)//cn_ocerst_in, numror )
 ! are we using XIOS to read the data? Part above will have to modified once XIOS
 ! can handle checking if variable is in the restart file (there will be no need to open
@@ -246,5 +242,5 @@
       !!                   ***  ROUTINE rst_read  ***
       !! 
-      !! ** Purpose :   Read files for restart (format fixed by jprstlib )
+      !! ** Purpose :   Read files for NetCDF restart
       !! 
       !! ** Method  :   Read in restart.nc file fields which are necessary for restart
@@ -263,4 +259,6 @@
       ENDIF
 
+      CALL iom_delay_rst( 'READ', 'OCE', numror )   ! read only ocean delayed global communication variables
+      
       ! Diurnal DSST 
       IF( ln_diurnal ) CALL iom_get( numror, jpdom_autoglo, 'Dsst' , x_dsst, ldxios = lrxios ) 
Index: /NEMO/trunk/src/OCE/LBC/lbc_lnk_generic.h90
===================================================================
--- /NEMO/trunk/src/OCE/LBC/lbc_lnk_generic.h90	(revision 10424)
+++ /NEMO/trunk/src/OCE/LBC/lbc_lnk_generic.h90	(revision 10425)
@@ -46,9 +46,10 @@
 
 #if defined MULTI
-   SUBROUTINE ROUTINE_LNK( ptab, cd_nat, psgn, kfld, cd_mpp, pval )
+   SUBROUTINE ROUTINE_LNK( cdname, ptab, cd_nat, psgn, kfld, cd_mpp, pval )
       INTEGER                     , INTENT(in   ) ::   kfld        ! number of pt3d arrays
 #else
-   SUBROUTINE ROUTINE_LNK( ptab, cd_nat, psgn      , cd_mpp, pval )
+   SUBROUTINE ROUTINE_LNK( cdname, ptab, cd_nat, psgn      , cd_mpp, pval )
 #endif
+      CHARACTER(len=*)            , INTENT(in   ) ::   cdname      ! name of the calling subroutine
       ARRAY_TYPE(:,:,:,:,:)                                        ! array or pointer of arrays on which the boundary condition is applied
       CHARACTER(len=1)            , INTENT(in   ) ::   NAT_IN(:)   ! nature of array grid-points
@@ -77,10 +78,5 @@
       ! ------------------------------- !
       !
-      IF( PRESENT( cd_mpp ) ) THEN     !==  halos filled with inner values  ==!
-         !
-         ! only fill the overlap area and extra allows 
-         ! this is in mpp case. In this module, just do nothing
-         !
-      ELSE                             !==  standard close or cyclic treatment  ==!
+      IF( .NOT. PRESENT( cd_mpp ) ) THEN  !==  standard close or cyclic treatment  ==!
          !
          DO jf = 1, ipf                   ! number of arrays to be treated
Index: /NEMO/trunk/src/OCE/LBC/lbc_lnk_multi_generic.h90
===================================================================
--- /NEMO/trunk/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 10424)
+++ /NEMO/trunk/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 10425)
@@ -14,8 +14,10 @@
 #   define PTR_ptab              pt4d
 #endif
-   SUBROUTINE ROUTINE_MULTI( pt1, cdna1, psgn1, pt2, cdna2, psgn2, pt3, cdna3, psgn3   &
+   SUBROUTINE ROUTINE_MULTI( cdname                                                    &
+      &                    , pt1, cdna1, psgn1, pt2, cdna2, psgn2, pt3, cdna3, psgn3   &
       &                    , pt4, cdna4, psgn4, pt5, cdna5, psgn5, pt6, cdna6, psgn6   &
       &                    , pt7, cdna7, psgn7, pt8, cdna8, psgn8, pt9, cdna9, psgn9, cd_mpp, pval)
       !!---------------------------------------------------------------------
+      CHARACTER(len=*)   ,                   INTENT(in   ) ::   cdname  ! name of the calling subroutine
       ARRAY_TYPE(:,:,:,:)          , TARGET, INTENT(inout) ::   pt1     ! arrays on which the lbc is applied
       ARRAY_TYPE(:,:,:,:), OPTIONAL, TARGET, INTENT(inout) ::   pt2  ,  pt3  , pt4  , pt5  , pt6  , pt7  , pt8  , pt9
@@ -48,5 +50,5 @@
       IF( PRESENT(psgn9) )   CALL ROUTINE_LOAD( pt9, cdna9, psgn9, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       !
-      CALL lbc_lnk_ptr( ptab_ptr, cdna_ptr, psgn_ptr, kfld, cd_mpp, pval )
+      CALL lbc_lnk_ptr( cdname, ptab_ptr, cdna_ptr, psgn_ptr, kfld, cd_mpp, pval )
       !
    END SUBROUTINE ROUTINE_MULTI
Index: /NEMO/trunk/src/OCE/LBC/lbc_nfd_ext_generic.h90
===================================================================
--- /NEMO/trunk/src/OCE/LBC/lbc_nfd_ext_generic.h90	(revision 10424)
+++ /NEMO/trunk/src/OCE/LBC/lbc_nfd_ext_generic.h90	(revision 10425)
@@ -106,5 +106,5 @@
                      ARRAY_IN(ji,ipj+jh,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(iju,ipj-1-jh,:,:,jf)
                   END DO
-                  ARRAY_IN(jpiglo,ipj+jh,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(1,ipj-1-jh,:,:,jf)
+                  ARRAY_IN(jpiglo,ipj+jh,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(jpiglo-2,ipj-1-jh,:,:,jf)
                END DO
             CASE ( 'V' )                               ! V-point
@@ -125,5 +125,5 @@
                      ARRAY_IN(ji,ipj+jh  ,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(iju,ipj-2-jh,:,:,jf)
                   END DO
-                  ARRAY_IN(jpiglo,ipj+jh,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(1,ipj-2-jh,:,:,jf)
+                  ARRAY_IN(jpiglo,ipj+jh,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(jpiglo-2,ipj-2-jh,:,:,jf)
                END DO
                DO ji = jpiglo/2+1, jpiglo-1
Index: /NEMO/trunk/src/OCE/LBC/lbc_nfd_generic.h90
===================================================================
--- /NEMO/trunk/src/OCE/LBC/lbc_nfd_generic.h90	(revision 10424)
+++ /NEMO/trunk/src/OCE/LBC/lbc_nfd_generic.h90	(revision 10425)
@@ -129,5 +129,5 @@
                   ARRAY_IN(ji,ipj,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(iju,ipj-1,:,:,jf)
                END DO
-               ARRAY_IN(jpiglo,ipj,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(1,ipj-1,:,:,jf)
+               ARRAY_IN(jpiglo,ipj,:,:,jf) = SGN_IN(jf) * ARRAY_IN(jpiglo-2,ipj-1,:,:,jf)
             CASE ( 'V' )                               ! V-point
                DO ji = 1, jpiglo
@@ -144,5 +144,5 @@
                   ARRAY_IN(ji,ipj  ,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(iju,ipj-2,:,:,jf)
                END DO
-               ARRAY_IN(jpiglo,ipj,:,:,jf) = SGN_IN(jf)  * ARRAY_IN(1,ipj-2,:,:,jf)
+               ARRAY_IN(jpiglo,ipj,:,:,jf) = SGN_IN(jf)   * ARRAY_IN(jpiglo-2,ipj-2,:,:,jf)
                DO ji = jpiglo/2+1, jpiglo-1
                   iju = jpiglo-ji
